/*
  BOUNDARY SCRIPT

  Creates zones that if entered will warn the player and then kill him if he doesn't leave

   October 2007 - norrin (norrins_nook@iprimus.com.au)  

  Version: 0.2                     
*******************************************************************************************************
  Start Boundary.sqf
*/

//Define Variables
_zone = _this select 0;
_unit = player;
_count = 0;
_x = false;
_y = false;


if (!local _unit) exitWith {};

//Get zone position
_zone_pos = getMarkerPos _zone;
_zone_pos_x = _zone_pos select 0;
_zone_pos_y = _zone_pos select 1;

//Get zone size
_zone_size = MarkerSize _zone;
_zone_size_x = (_zone_size select 0);
_zone_size_y = (_zone_size select 1);

while {true} do
{	
	_unit = player;	
	
	//Get player's position 
	_pos = getPos _unit;
	_pos_x = _pos select 0;
	_pos_y = _pos select 1;
	if (abs(_pos_x - _zone_pos_x) < _zone_size_x || abs(_zone_pos_x - _pos_x) < _zone_size_x) then {_x = true} else {_x = false};
	if (abs(_pos_y - _zone_pos_y) < _zone_size_y || abs(_zone_pos_y - _pos_y) < _zone_size_y) then {_y = true} else {_y = false};	
	_dir_unit = getDir _unit;
 	sleep 1;
	
	//If player in boundary zone, give a ten second warning then kill player if still present in zone 
	while {alive _unit && _x && _y} do
	{			
 		if (_count == 0 && isplayer _unit && local _unit) then 
 		{
	 		Titletext ["You are leaving the field of combat.  You have 10 seconds to return to the battlefield","PLAIN", 1];
	 		if (_dir_unit <= 22.5 || _dir_unit > 337.5) then {hint  "Move south to exit zone"};
			if (_dir_unit > 22.5 &&	_dir_unit <= 67.5) then {hint  "Move south-west to exit zone"};
			if (_dir_unit > 67.5 &&	_dir_unit <= 112.5) then {hint  "Move west to exit zone"};
			if (_dir_unit > 112.5 && _dir_unit <= 157.5) then {hint  "Move north-west to exit zone"};
			if (_dir_unit > 157.5 && _dir_unit <= 202.5) then {hint  "Move north to exit zone"};
			if (_dir_unit > 202.5 && _dir_unit <= 247.5) then {hint  "Move north-east to exit zone"};
			if (_dir_unit > 247.5 && _dir_unit <= 292.5) then {hint  "Move east to exit zone"};
			if (_dir_unit > 292.5 && _dir_unit <= 337.5) then {hint  "Move south-east to exit zone"};
	 	};
		_counter = 10 - _count;
		call compile format ["if (isplayer _unit && local _unit && _counter >= 0) then {titleCut [""Time Remaining: %1"", ""PLAIN DOWN"", 0.1]}", _counter];
		if (_x && _y && _counter == 0) then {_unit SetDammage 1; _x = false; _y = false};
		sleep 1;
		_count = _count + 1;
		_pos = getPos _unit;
		_pos_x = _pos select 0;
		_pos_y = _pos select 1;
		if (abs(_pos_x - _zone_pos_x) < _zone_size_x || abs(_zone_pos_x - _pos_x) < _zone_size_x) then {_x = true} else {_x = false};
		if (abs(_pos_y - _zone_pos_y) < _zone_size_y || abs(_zone_pos_y - _pos_y) < _zone_size_y) then {_y = true} else {_y = false};	 
	};

	
	if (local _unit && _count > 0) then {Titletext [" ","PLAIN", 0.05]; TitleCut ["","PLAIN DOWN", 0.1]; hint ""};
	
	sleep 1;
	_count = 0;
	_x = false;
	_y = false;
	
};	
